#!/bin/bash

##############################################################
#                                                            #
#       Scheme Selector - Desktop User Preferences           #
#                                                            #
##############################################################
#                                                            #
#      File:           /opt/MaXX/bin/scheme_selector.sh      #
#      Version:        2.2 (Octane Release)                  #
#      Last modified:                                        #
#                                                            #
#      By whom:        Eric Masson                           #
#      Contact:        eric.masson@maxxinteractive.com       #
#                                                            #
##############################################################

print_selection(){
	printf "\n"
	echo "MaXX Interactive Desktop Scheme Selector"
	echo "----------------------------------------"
	printf "\n"
	
	echo "1) `is_Selected 'Arizona'`        9)  `is_Selected 'IndigoMagic'`  17) `is_Selected 'Monet'`         25) `is_Selected 'Sargent'`"
	echo "2) `is_Selected 'Bayou'`          10) `is_Selected 'Inverness'`    18) `is_Selected 'Pacific'`       26) `is_Selected 'Titian'`"
	echo "3) `is_Selected 'BlackAndWhite'`  11) `is_Selected 'KeyWest'`      19) `is_Selected 'Potrero'`       27) `is_Selected 'Turner'`"
	echo "4) `is_Selected 'Buckingham'`     12) `is_Selected 'Lascaux'`      20) `is_Selected 'Print'`         28) `is_Selected 'Vancouver'`"
	echo "5) `is_Selected 'DarkBliss'`      13) `is_Selected 'Leonardo'`     21) `is_Selected 'RedGreenSafe'`  29) `is_Selected 'VanGogh'`"
	echo "6) `is_Selected 'Gainsborough'`   14) `is_Selected 'Mendocino'`    22) `is_Selected 'Rembrandt'`     30) `is_Selected 'Whistler'`"
	echo "7) `is_Selected 'Gotham'`         15) `is_Selected 'Metropolis'`   23) `is_Selected 'Rio'`           31) `is_Selected 'Willis'`"
	echo "8) `is_Selected 'GrayScale'`      16) `is_Selected 'Milan'`        24) `is_Selected 'RoseGarden'`"

	printf "\n"
	echo "0) exit"
	printf "\n"
}

is_Selected(){
	
	if [ "$1" == "$SELECTED_SCHEME" ] 
		then
			printf "$1 *"
		else 
			printf "$1  "
	fi
}


quit(){
printf "\n"
	echo "Program terminated gracefully :)\n"
	exit 1
}


do_select(){
	msettings S Desktop.Colors.SgiScheme=$1 > /dev/null
}

###################################################3
#
#   STARTS HERE
#
SELECTED_SCHEME=`msettings Desktop.Colors.SgiScheme`
if [ "$SCHEME" == "failed" ]; 
then
	echo "MAXX_THEME is NOT DEFINED!"
	echo "The IndigoMagic Scheme is defaulted"
	SELECTED_SCHEME="IndigoMagic"
fi

while true
do
	print_selection
	read -p ">> Selection the desired SGI Scheme number: " choice

	case $choice in
		0)
			quit
			;;
		1)
			do_select "Arizona"
			break
			;;
		2)
			do_select "Bayou"
			break
            		;;
		3)
			do_select "BlackAndWhite"
			break
			;;
		4)
			do_select "Buckingham"
			break
			;;
		5)
			do_select "DarkBliss"
			break
            		;;
		6)
			do_select "Gainsborough"
			break
			;;
		7)
			do_select "Gotham"
			break
			;;
		8)
			do_select "GrayScale"
			break
            		;;
		9)
			do_select "IndigoMagic"
			break
			;;
		10)
			do_select "Inverness"
			break
			;;
		11)
			do_select "KeyWest"
			break
            		;;
		12)
			do_select "Lascaux"
			break
			;;
		13)
			do_select "Leonardo"
			break
			;;
		14)
			do_select "Mendocino"
			break
            		;;
		15)
			do_select "Metropolis"
			break
			;;
		16)
			do_select "Milan"
			break
			;;
		17)
			do_select "Monet"
			break
            		;;
		18)
			do_select "Pacific"
			break
			;;
		19)
			do_select "Potrero"
			break
			;;
		20)
			do_select "Print"
			break
            		;;
		21)
			do_select "RedGreenSafe"
			break
			;;
		22)
			do_select "Rembrandt"
			break
			;;
		23)
			do_select "Rio"
			break
            		;;
		24)
			do_select "RoseGarden"
			break
			;;
		25)
			do_select "Sargent"
			break
			;;
		26)
			do_select "Titian"
			break
           	;;
		27)
			do_select "Turner"
			break
			;;
		28)
			do_select "Vancouver"
			break
			;;
		29)
			do_select "VanGogh"
			break
            		;;
		30)
			do_select "Whistler"
			break
			;;
		31)
			do_select "Willis"
			break
			;;
		*)
		 	printf "\n"
		 	echo "Invalid selection, enter a valid selection."
			;;
	esac
done

$MAXX_BIN/telldesktop stop
$MAXX_BIN/desktopenv --all
$MAXX_BIN/telldesktop refresh
$MAXX_BIN/telldesktop start
