#!/bin/bash


##############################################################
## Load Nvidia Settings

if [ -x /usr/bin/nvidia-settings ]; then
/usr/bin/nvidia-settings -l 
fi

##############################################################
## Setup default ENV VARIABLES

if [ -f /opt/MaXX/etc/system.desktopenv ]; then
. /opt/MaXX/etc/system.desktopenv
fi


##############################################################
## Setup user overwites ENV VARIABLES

if [ -f $HOME/.maxxdesktop/desktopenv ]; then
. $HOME/.maxxdesktop/desktopenv
else
 cd $HOME 
 /opt/MaXX/share/misc/HOME/initMaXX-Desktop-Home.sh
 /opt/MaXX/bin$BITS/xconfirm -icon info -t "First time user! The MaXX Interactive Desktop is now properly configured for the user accout: $USERNAME"  > /dev/null 2>&1 &
fi


##############################################################
## Define font ENV VARIABLES

xset +fp /opt/MaXX/share/fonts/sgi
export font=-sgi-screen-medium-r-normal-*-*-150-*-*-m-*-iso8859-1


##############################################################
# Prepared each Screen(s) and load settings on a per screen basis


  xset -b
  xsetroot -solid SkyBlue4
#  xgamma -gamma 1.2 -display $screen


##############################################################
## Load Resources and Settings

# X11 Standard Resources
xrdb -load -quiet $HOME/.Xdefaults
xrdb -merge -quiet $HOME/Sgiresources



##############################################################
## Start standard applications for each Screen(s)

# might need some work for multi XDisplay system with more that one WM running!


export WORKSPACE=myspace

xclock  -geometry +30+602 &
/opt/MaXX/bin/toolchest &
/opt/MaXX/bin/gr_osview -geometry 350x450+10+700   &
/opt/MaXX/bin/fm -p=$WORKSPACE &


##############################################################
##   Last application to run

##############################################################
# Window Manager and Composition manager
#

 taskset 0 /opt/MaXX/bin/XcompMgr &


/opt/MaXX/bin/5Dwm

