/*  MaXX License goes here

*/

#ifndef scheme_H
#define scheme_H

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>

#ifdef __cplusplus
extern "C" {
#endif

/********    Public Function Declarations    ********/

extern Pixel getColorResource(Widget w, const char *name, const char *classname);
extern Status getXColorResource(Widget w, const char *name, const char *classname, XColor *xcolor);
extern char* getStringResource(Widget w, const char *name, const char *classname);
extern int getBooleanResource(Widget w, const char *name, const char *className);
extern int isDarkScheme(Widget w, const char *classname);
extern int isDarkBackground(Widget w, const char *classname);
extern int isModernLook(Widget w, const char *classname);
extern int isSmoothText(Widget w, const char *classname);

#ifdef __cplusplus
}  
#endif

#endif
