#pragma once

#include "Vue/Core/Foundation.h"
#include "Vue/Grafix/ItemView/Item.h"

namespace Vue {

    struct ItemProperties {
        uint32_t owner{};
        std::uintmax_t fileSize{};
        std::filesystem::perms permission{};
        uint64_t lastModificationDate{};
        bool isExecutable = false;
        ItemProperties() = default;
    };


    class DirEntryItem : public Item {
    public:
        explicit DirEntryItem(const std::filesystem::path& dirPath) ;
        explicit DirEntryItem(const std::filesystem::directory_entry& dirEntry) ;


        ItemProperties& getProperties() { return properties;}

        std::filesystem::path& getPath() { return path;}

    protected:
        void populateProperties();
    private:
        std::filesystem::path path{};
        ItemProperties properties{};

    };
}