#!/bin/bash

############################################################
#
#  MaXXdesktop - First Time User Launch 
#                 v 2.2.0 - alpha 1
#

# make backup of existing User Preferences files in $HOME/.maxxdesktop
do_dot_maxxdesktop_backup() {

printf "*** Found an existing MaXXdesktop User Preferences Directory.\n    --> Don't worry, I will make a backup it as: $HOME/dot.maxxdesktop-$timestp.\n"

mv $HOME/.maxxdesktop $HOME/dot.maxxdesktop-$timestp

}

# Setup User Preferences
do_install_dot_maxxdesktop(){

cp -rp /opt/MaXX/share/misc/HOME/dot.maxxdesktop $HOME/.maxxdesktop
echo ">> MaXXdesktop User Preferences Installed into  $HOME/.maxxdesktop"
}

# make backup of existing User files
do_backup_home_files(){

if [ -f  $HOME/Sgiresources ]; then
mv $HOME/Sgiresources $HOME/Sgiresources-$timestp
fi

if [ -f  $HOME/.Xdefaults ]; then
mv $HOME/.Xdefaults $HOME/dot.Xdefaults-$timestp
fi

if [ -f  $HOME/.dir_colors ]; then
mv $HOME/.dir_colors $HOME/dot.dir_colors-$timestp
fi

if [ -f  $HOME/.mwmrc ]; then
mv $HOME/.mwmrc $HOME/dot.mwmrc-$timestp
fi

if [ -f  $HOME/.xinitrc ]; then
mv $HOME/.xinitrc $HOME/dot.xinitrc-$timestp
fi

if [ -f  $HOME/.sgisession ]; then
mv $HOME/.sgisession $HOME/dot.sgisession-$timestp
fi

if [ -f  $HOME/.chestrc ]; then
mv $HOME/.chestrc $HOME/dot.chestrc-$timestp
fi

}


# Setup User's $HOME dot files
do_install_home_files(){

cp /opt/MaXX/share/misc/HOME/Sgiresources $HOME/Sgiresources
cp /opt/MaXX/share/misc/HOME/dot.Xdefaults $HOME/.Xdefaults
cp /opt/MaXX/share/misc/HOME/dot.dir_colors $HOME/.dir_colors
cp /opt/MaXX/share/misc/HOME/dot.mwmrc $HOME/.mwmrc
cp /opt/MaXX/share/misc/HOME/dot.xinitrc $HOME/.xinitrc
cp /opt/MaXX/share/misc/HOME/dot.sgisession $HOME/.sgisession
cp /opt/MaXX/share/misc/HOME/dot.chestrc $HOME/.chestrc

}

# make backup of existing ROX-Filer files
do_rox_backup(){

printf "*** Found an existing ROX-Filer Configuratrion Directory.\n    --> Don't worry, I will make a backup it as: $HOME/.config/rox.sourceforge.net-$timestp.\n"

mv $HOME/.config/rox.sourceforge.net $HOME/.config/rox.sourceforge.net-$timestp

}
# Setup ROX-Filer Defaults
do_install_rox_files(){

cp -r  /opt/MaXX/share/misc/HOME/rox.sourceforge.net $HOME/.config/rox.sourceforge.net
echo ">> ROX-Filer User files installation completed."

}

# Setup GTK Theme and Icons 
do_gtk_stuff(){

# Adding symlinks for GTK+ Themes
mkdir -p $HOME/.themes
ln -fs /opt/MaXX/share/themes/* $HOME/.themes/

# Adding symlinks for ICONS and Cursors
mkdir -p $HOME/.icons
ln -fs /opt/MaXX/share/icons/* $HOME/.icons/

}



#################################################
#
#    main()
#

cd $HOME

printf "\n"
echo "MaXXdesktop v2.2.0 User Preferences First-time User"
echo "----------------------------------------------------"

timestp=`date +%F_%T`

# User Preferences
if [ -d  $HOME/.maxxdesktop ]; then
do_dot_maxxdesktop_backup
fi

do_install_dot_maxxdesktop


# ROX-Filer files
if [ -d  $HOME/.config/rox.sourceforge.net ]; then
do_rox_backup
fi

do_install_rox_files


# HOME files
do_backup_home_files

do_install_home_files


# GTK
do_gtk_stuff


printf "\nMaXXdesktop First Time User Preferences Setup Complete.\n"
